diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
similarity index 74%
rename from src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
index b4765594a..59b149d99 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.gui.modelviewer.elements;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import org.lwjgl.input.Keyboard;
 
-public class GuiListenerTextField extends GuiListenerButton implements ITextField {
-    private final FontRenderer fontRenderer;
+public class ListenerTextFieldElement extends ListenerButtonElement implements ITextField {
+    private final Font font;
     private String text = "";
     private String prefaceText = "";
     private int maxStringLength;
@@ -16,26 +16,26 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
     public boolean isFocused;
     public boolean isEnabled;
     public boolean removeTextOnClick = false;
-    public GuiScreen parent;
+    public Screen parent;
     private ITextChangeListener textChangeListener;
     private String placeholder;
     public boolean drawBackground = true;
     public final TextFieldEditor editor;
 
-    public GuiListenerTextField(GuiScreen parent, FontRenderer fontrenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
+    public ListenerTextFieldElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
     {
         super(-1, xPosition, yPosition, width, height, "");
         playSound = false;
         isFocused = false;
         isEnabled = true;
         this.parent = parent;
-        fontRenderer = fontrenderer;
+        this.font = font;
         this.editor = new TextFieldEditor(this);
         this.placeholder = placeholder;
         setText(defaultText);
         editor.setCursor(10000);
     }
-    public GuiListenerTextField setPrefaceText(String prefaceText){
+    public ListenerTextFieldElement setPrefaceText(String prefaceText){
         this.prefaceText = prefaceText;
         return this;
     }
@@ -118,24 +118,24 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
         }
         if (text.isEmpty() && !isFocused)
         {
-            drawString(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+            drawString(font, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
         }
 
         if(isEnabled)
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / fontRenderer.getCharWidth('_');
+            int maxDisplayableChars = this.width / font.getCharWidth('_');
 
             if (!text.isEmpty() || isFocused){
                 if(prefaceText.length() + text.length() <= maxDisplayableChars-1){
-                    drawString(fontRenderer, prefaceText + text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                    drawString(font, prefaceText + text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
                 } else {
                     //only draw the part of the string that's maxDisplayableChars chars around the cursor
                     String newString = prefaceText + text;
                     int begin = Math.max(0,cursor - maxDisplayableChars);
                     int end = Math.max(maxDisplayableChars,Math.min(newString.length(),cursor));
-                    drawString(fontRenderer, newString.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                    drawString(font, newString.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
                 }
             }
             if (drawCursor)
@@ -144,21 +144,21 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
                 if (!text.isEmpty() || isFocused){
                     currentText = prefaceText + text;
                 }
-                int width = fontRenderer.getStringWidth(currentText);
+                int width = font.getStringWidth(currentText);
                 if (cursor < text.length())
                 {
-                    width = fontRenderer.getStringWidth(text.substring(0, cursor)) + fontRenderer.getStringWidth(prefaceText);
+                    width = font.getStringWidth(text.substring(0, cursor)) + font.getStringWidth(prefaceText);
                 }
                 if(width >= this.width-4){
                     // width of the text box - the width of the last character
-                    width = (this.width-4) - fontRenderer.getStringWidth(currentText.substring(currentText.length()-2,currentText.length()-1));
+                    width = (this.width-4) - font.getStringWidth(currentText.substring(currentText.length()-2,currentText.length()-1));
                 }
-                drawString(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
             }
         }
         else
         {
-            drawString(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+            drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
         }
     }
 
@@ -177,13 +177,13 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
         return isFocused || super.isHovered(mouseX, mouseY);
     }
 
-    public GuiListenerTextField setTextChangeListener(ITextChangeListener textChangeListener) {
+    public ListenerTextFieldElement setTextChangeListener(ITextChangeListener textChangeListener) {
         this.textChangeListener = textChangeListener;
         return this;
     }
 
     public interface ITextChangeListener
     {
-        void textChanged(GuiListenerTextField textField);
+        void textChanged(ListenerTextFieldElement textField);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
similarity index 80%
rename from src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
index e1bafcda2..7eff42c73 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.gui.modelviewer.elements;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.Font;
 
-public abstract class GuiTextCycle<T> extends GuiListenerButton{
+public abstract class TextCycleElement<T> extends ListenerButtonElement {
     private T currentElement;
     private final T defaultElement;
-    public final GuiListenerButton prevButton;
-    public final GuiListenerButton nextButton;
-    public final GuiListenerTextField textField;
-    public GuiTextCycle(GuiScreen parent, FontRenderer fontRenderer, int xPosition, int yPosition, int width, int height, T initialElement) {
+    public final ListenerButtonElement prevButton;
+    public final ListenerButtonElement nextButton;
+    public final ListenerTextFieldElement textField;
+    public TextCycleElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, T initialElement) {
         super(-1, xPosition, yPosition, width, height, "");
 
-        textField = new GuiListenerTextField(parent, fontRenderer, 0, yPosition, width - height * 2 - 2, height, getNameFromElement(initialElement), "");
+        textField = new ListenerTextFieldElement(parent, font, 0, yPosition, width - height * 2 - 2, height, getNameFromElement(initialElement), "");
         textField.setKeyListener(key -> {
             String text = textField.getText();
             setCurrentElement(getElementFromString(text));
@@ -24,14 +24,14 @@ public abstract class GuiTextCycle<T> extends GuiListenerButton{
             textField.setText(text);
         });
 
-        prevButton = new GuiListenerButton(-1, xPosition, yPosition, height, height, "<");
+        prevButton = new ListenerButtonElement(-1, xPosition, yPosition, height, height, "<");
         prevButton.setActionListener(() -> {
             setCurrentElement(cycleElement(getCurrentElement(), -1));
         });
 
         textField.xPosition = prevButton.xPosition + prevButton.width + 1;
 
-        nextButton = new GuiListenerButton(-1, textField.xPosition + textField.width + 1, yPosition, height, height, ">");
+        nextButton = new ListenerButtonElement(-1, textField.xPosition + textField.width + 1, yPosition, height, height, ">");
         nextButton.setActionListener(() -> {
             setCurrentElement(cycleElement(getCurrentElement(), 1));
         });
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptionsButton.java b/src/main/java/net/minecraft/client/gui/options/OptionsButtonElement.java
similarity index 54%
rename from src/main/java/net/minecraft/client/gui/options/GuiOptionsButton.java
rename to src/main/java/net/minecraft/client/gui/options/OptionsButtonElement.java
index caad98382..84b8ad1be 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptionsButton.java
+++ b/src/main/java/net/minecraft/client/gui/options/OptionsButtonElement.java
@@ -1,31 +1,31 @@
 package net.minecraft.client.gui.options;
 
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.option.Option;
 
 // Referenced classes of package net.minecraft.src:
 //            GuiButton, EnumOptions
 
-public class GuiOptionsButton extends GuiButton
+public class OptionsButtonElement extends ButtonElement
 {
 
-    public GuiOptionsButton(int id, int xPosition, int yPosition, String text)
+    public OptionsButtonElement(int id, int xPosition, int yPosition, String text)
     {
         this(id, xPosition, yPosition, null, text);
     }
 
-    public GuiOptionsButton(int id, int xPosition, int yPosition, int width, int height, String text)
+    public OptionsButtonElement(int id, int xPosition, int yPosition, int width, int height, String text)
     {
         super(id, xPosition, yPosition, width, height, text);
         option = null;
     }
 
-    public GuiOptionsButton(int id, int xPosition, int yPosition, Option<?> option, String text)
+    public OptionsButtonElement(int id, int xPosition, int yPosition, Option<?> option, String text)
     {
         this(id, xPosition, yPosition, 150, 20, option, text);
     }
 
-    public GuiOptionsButton(int id, int xPosition, int yPosition, int width, int height, Option<?> option, String text)
+    public OptionsButtonElement(int id, int xPosition, int yPosition, int width, int height, Option<?> option, String text)
     {
         super(id, xPosition, yPosition, width, height, text);
         this.option = option;
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
similarity index 82%
rename from src/main/java/net/minecraft/client/gui/options/GuiOptions.java
rename to src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
index edb1b6dc2..8df1f345e 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
+++ b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.options;
 
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.options.components.KeyBindingComponent;
 import net.minecraft.client.gui.options.components.OptionsComponent;
 import net.minecraft.client.gui.options.data.OptionsPage;
@@ -21,8 +21,8 @@ import org.lwjgl.opengl.GL11;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL11.glEnable;
 
-public class GuiOptions
-    extends GuiScreen
+public class OptionsScreen
+    extends Screen
 {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
@@ -43,17 +43,17 @@ public class GuiOptions
     private OptionsPage selectedPage;
     private OptionsComponent clickedComponent;
     private int clickedComponentY;
-    private GuiRenderItem renderItem = null;
+    private ItemElement renderItem = null;
 
     private boolean doOptionsScroll = true;
     private boolean doPagesListScroll = true;
 
-    public GuiOptions(GuiScreen parent)
+    public OptionsScreen(Screen parent)
     {
         this(parent, OptionsPages.GENERAL);
     }
 
-    public GuiOptions(GuiScreen parent, OptionsPage selectedPage)
+    public OptionsScreen(Screen parent, OptionsPage selectedPage)
     {
         super(parent);
         this.selectedPage = selectedPage;
@@ -64,7 +64,7 @@ public class GuiOptions
     {
         super.init();
 
-        controlList.add(new GuiButton(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
+        buttons.add(new ButtonElement(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
 
         top = TOP_SPACING;
         bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
@@ -72,35 +72,35 @@ public class GuiOptions
         optionsScrollRegionHeight = bottom - top;
         pagesListScrollRegionHeight = bottom - top;
 
-        this.renderItem = new GuiRenderItem(mc);
+        this.renderItem = new ItemElement(mc);
 
         this.selectedPage.initComponents(mc);
     }
 
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY) {
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            if (key == Keyboard.KEY_ESCAPE) {
+            if (eventKey == Keyboard.KEY_ESCAPE) {
                 pickingKeyBinding = null;
                 pickingKeyBindingComponent = null;
                 return;
             }
-            pickingKeyBinding.bind(InputDevice.keyboard, key);
+            pickingKeyBinding.bind(InputDevice.keyboard, eventKey);
             pickingKeyBindingComponent.update();
             pickingKeyBinding = null;
             pickingKeyBindingComponent = null;
             return;
         }
 
-        if (key == Keyboard.KEY_ESCAPE)
+        if (eventKey == Keyboard.KEY_ESCAPE)
         {
-            mc.displayGuiScreen(getParentScreen());
+            mc.displayScreen(getParentScreen());
         }
         else
         {
             for (OptionsComponent component : selectedPage.getComponents())
             {
-                component.onKeyPress(key, c);
+                component.onKeyPress(eventKey, eventCharacter);
             }
         }
     }
@@ -127,7 +127,7 @@ public class GuiOptions
                 textColor = 0xFFFFFFA0;
             }
             renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
-            mc.fontRenderer.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            mc.font.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
     }
@@ -141,19 +141,19 @@ public class GuiOptions
     }
 
     @Override
-    protected void buttonPressed(GuiButton guibutton) {
-        super.buttonPressed(guibutton);
+    protected void buttonClicked(ButtonElement button) {
+        super.buttonClicked(button);
 
-        if (guibutton.id == 0)
+        if (button.id == 0)
         {
-            mc.displayGuiScreen(getParentScreen());
+            mc.displayScreen(getParentScreen());
             mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
         }
     }
 
     @Override
-    public void onClosed() {
-        super.onClosed();
+    public void removed() {
+        super.removed();
         mc.gameSettings.saveOptions();
     }
 
@@ -198,19 +198,19 @@ public class GuiOptions
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float renderPartialTicks)
+    public void render(int xm, int ym, float renderPartialTicks)
     {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            mouseX = -1;
-            mouseY = -1;
-        } else if (doOptionsScroll && mouseX > pagesListWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
+            xm = -1;
+            ym = -1;
+        } else if (doOptionsScroll && xm > pagesListWidth + SEPARATOR_WIDTH + PADDING && xm < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollOptions(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollOptions(Mouse.getDWheel() / -0.05f);
             }
             onScrollOptions();
-        } else if (doPagesListScroll && mouseX >= 0 && mouseX <= pagesListWidth) {
+        } else if (doPagesListScroll && xm >= 0 && xm <= pagesListWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
@@ -223,13 +223,13 @@ public class GuiOptions
         pageWidth = width - (pagesListWidth + SEPARATOR_WIDTH + (PADDING * 2));
         I18n i18n = I18n.getInstance();
 
-        drawDefaultBackground();
+        renderBackground();
         overlayBackground(0, width, 0, top);
         overlayBackground(0, width, bottom, height);
 
         Scissor.enable(0, top, width, bottom - top);
-        if (mouseY >= top && mouseY <= bottom) {
-            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, mouseX, mouseY);
+        if (ym >= top && ym <= bottom) {
+            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, xm, ym);
         } else {
             drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, -1, -1);
         }
@@ -241,8 +241,8 @@ public class GuiOptions
         if (pagesListHeight < bottom - top) {
             pagesListY = top + (bottom - top - pagesListHeight) / 2;
         }
-        if (mouseY >= top && mouseY <= bottom) {
-            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, mouseX, mouseY);
+        if (ym >= top && ym <= bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, xm, ym);
         } else {
             drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, -1, -1);
         }
@@ -287,16 +287,16 @@ public class GuiOptions
         overlayBackground(pagesListWidth, pagesListWidth + SEPARATOR_WIDTH, top, bottom);
 
         String titleLanguageKey = "gui.options.title";
-        drawStringCentered(fontRenderer, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
+        drawStringCentered(font, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
 
-        drawOptionsScrollBar(mouseX, mouseY);
-        drawPagesListScrollBar(mouseX, mouseY);
+        drawOptionsScrollBar(xm, ym);
+        drawPagesListScrollBar(xm, ym);
 
-        super.drawScreen(mouseX, mouseY, renderPartialTicks);
+        super.render(xm, ym, renderPartialTicks);
 
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             drawRect(0, 0, width, height, 0xA0000000);
-            drawStringCenteredNoShadow(fontRenderer, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), width / 2, height / 2 - 4, 0xffffff);
+            drawStringCenteredNoShadow(font, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), width / 2, height / 2 - 4, 0xffffff);
         }
     }
 
@@ -391,40 +391,40 @@ public class GuiOptions
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            pickingKeyBinding.bind(InputDevice.mouse, mouseButton);
+            pickingKeyBinding.bind(InputDevice.mouse, buttonNum);
             pickingKeyBindingComponent.update();
             pickingKeyBinding = null;
             pickingKeyBindingComponent = null;
             return;
         }
 
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
 
         int left = pagesListWidth + SEPARATOR_WIDTH + PADDING;
 
-        if (mouseX >= pagesListWidth + SEPARATOR_WIDTH && mouseY >= top && mouseY <= bottom) {
+        if (mx >= pagesListWidth + SEPARATOR_WIDTH && my >= top && my <= bottom) {
             int componentY = top - (int) optionsScrollAmount;
             for (OptionsComponent component : selectedPage.getComponents())
             {
-                if (mouseX >= left && mouseX <= left + pageWidth - PADDING && mouseY >= componentY && mouseY <= componentY + component.getHeight()) {
-                    component.onMouseClick(mouseButton, left, componentY, pageWidth - PADDING, mouseX - left, mouseY - componentY);
+                if (mx >= left && mx <= left + pageWidth - PADDING && my >= componentY && my <= componentY + component.getHeight()) {
+                    component.onMouseClick(buttonNum, left, componentY, pageWidth - PADDING, mx - left, my - componentY);
                     clickedComponent = component;
                     clickedComponentY = componentY;
                     break;
                 }
                 componentY += component.getHeight();
             }
-        } else if (mouseX >= 0 && mouseX <= pagesListWidth && mouseY >= top && mouseY <= bottom) {
+        } else if (mx >= 0 && mx <= pagesListWidth && my >= top && my <= bottom) {
             int pagesListHeight = getTotalPagesListHeight();
             int pagesListY = top - (int) pagesListScrollAmount;
             if (pagesListHeight < bottom - top) {
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
             }
             for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
-                if (mouseX >= 0 && mouseX <= pagesListWidth && mouseY >= pagesListY && mouseY <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                if (mx >= 0 && mx <= pagesListWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
                     optionsScrollAmount = 0;
                     selectedPage = page;
                     this.selectedPage.initComponents(mc);
@@ -436,42 +436,42 @@ public class GuiOptions
             }
         }
 
-        clickX = mouseX;
-        clickY = mouseY;
+        clickX = mx;
+        clickY = my;
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
+    public void mouseReleased(int mx, int my, int buttonNum) {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) return;
 
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+        super.mouseReleased(mx, my, buttonNum);
 
         int left = pagesListWidth + SEPARATOR_WIDTH + PADDING;
-        if (mouseY >= top && mouseY <= bottom) {
+        if (my >= top && my <= bottom) {
             if (clickedComponent != null) {
-                if (mouseButton >= 0) {
-                    clickedComponent.onMouseRelease(mouseButton, left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                if (buttonNum >= 0) {
+                    clickedComponent.onMouseRelease(buttonNum, left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
                     clickedComponent = null;
                 } else {
-                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
                 }
             }
         }
 
-        if(mouseButton >= 0) {
+        if(buttonNum >= 0) {
             clickX = null;
             clickY = null;
         }
     }
 
     @Override
-    public void drawDefaultBackground() {
-        super.drawDefaultBackground();
+    public void renderBackground() {
+        super.renderBackground();
 
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -502,7 +502,7 @@ public class GuiOptions
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptionButton.java b/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
similarity index 67%
rename from src/main/java/net/minecraft/client/gui/options/GuiOptionButton.java
rename to src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
index a5f60d32d..adcbe7cd4 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptionButton.java
+++ b/src/main/java/net/minecraft/client/gui/options/OverlayButtonElement.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui.options;
 
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.util.helper.Listener;
 import net.minecraft.core.util.helper.Toggleable;
 import net.minecraft.client.option.Option;
 
-public class GuiOptionButton<E extends Option<?> & Toggleable> extends GuiButton implements Listener<GuiButton>{
+public class OverlayButtonElement<E extends Option<?> & Toggleable> extends ButtonElement implements Listener<ButtonElement>{
 
 	public final GameSettings settings;
 	public final E option;
 	
-	public GuiOptionButton(GameSettings settings, E option) {
+	public OverlayButtonElement(GameSettings settings, E option) {
 		super(0, 0, 0, 0, 0, null);
 		
 		this.settings = settings;
@@ -23,7 +23,7 @@ public class GuiOptionButton<E extends Option<?> & Toggleable> extends GuiButton
 	}
 
 	@Override
-	public void listen(GuiButton e) {
+	public void listen(ButtonElement e) {
 		option.toggle();
 		
 		updateString();
